<template>
  <div class="companyEditFormContainer">
    <h2>Modify Company</h2>
    <div>
      <label>Name</label>
      <input type="text" v-model="companyToEdit.name" />
      <div><img v-bind:src="companyToEdit.logo" /></div>
      <label>Logo</label>
      <input type="text" v-model="companyToEdit.logo" />
      <input
        type="file"
        ref="file"
        title="Upload logo file"
        @change="handleFileUpload"
      />
      <label>Established</label>
      <input type="date" v-model="companyToEdit.established" />
      <label>Employees</label>
      <input
        type="number"
        min="0"
        max="1000000"
        step="1"
        name="employees"
        v-model="companyToEdit.employees"
      />
      <label>Revenue (&euro;)</label>
      <input
        type="number"
        min="-1000000000000"
        max="1000000000000"
        step="1"
        v-model="companyToEdit.revenue"
      />
      <label>Net income (&euro;)</label>
      <input
        type="number"
        min="-1000000000000"
        max="1000000000000"
        step="1"
        v-model="companyToEdit.netIncome"
      />
      <label>Securities</label>
      <input
        type="number"
        min="0"
        max="1000000000000"
        step="1"
        v-model="companyToEdit.securities"
      />
      <label>Security price (&euro;)</label>
      <input type="number" step="0.01" v-model="companyToEdit.securityPrice" />
      <label>Dividends (&euro;)</label>
      <input type="number" step="0.01" v-model="companyToEdit.dividends" />
      <ErrorBox v-if="errors.length > 0" :errors="errors" />
      <button name="save" @click="handleSave">Save</button>
    </div>
  </div>
</template>

<script>
import ErrorBox from "./ErrorBox.vue";
import CompanyValidator from "../util/CompanyValidator";
import Company from "../model/Company";
import Util from "../util/Util";
import FetchApi from "../util/FetchApi";

export default {
  name: "CompanyEdit",
  props: {
    company: null,
  },
  data() {
    return {
      companyToEdit: new Company(),
      errors: [],
    };
  },
  created() {
    if (this.company != null) {
      this.companyToEdit = { ...this.company };
    }
  },
  emits: ["company-saved"],
  methods: {
    async handleFileUpload() {
      const logoFile = this.$refs.file.files[0];
      if (logoFile) {
        try {
          const uploadResponse = await FetchApi.postFile(logoFile);
          this.companyToEdit.logo = uploadResponse.url;
        } catch (e) {
          Util.handleError(e, () => this.$router.push({ name: "Login" }));
        }
      }
    },
    async handleSave() {
      this.errors = new CompanyValidator(this.companyToEdit)
        .validateName()
        .validateLogo()
        .validateEstablished()
        .validateEmployees().validationErrors;

      if (this.errors.length == 0) {
        try {
          await FetchApi.postCompany(this.companyToEdit);
          this.$parent.$emit("action-completed");
        } catch (e) {
          Util.handleError(e, () => this.$router.push({ name: "Login" }));
        }
      }
    },
  },
  components: {
    ErrorBox,
  },
};
</script>